Index: trunk/source/processes/electromagnetic/adjoint/src/G4AdjointBremsstrahlungModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4AdjointBremsstrahlungModel.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4AdjointBremsstrahlungModel.cc	(revision 1196)
@@ -428,237 +362,33 @@
 ////////////////////////////////////////////////////////////////////////////////
 //
-G4double G4AdjointBremsstrahlungModel::DiffCrossSectionPerVolumePrimToSecond3(
-  				      const G4Material* aMaterial,
-                                      G4double kinEnergyProj,  // kinetic energy of the primary particle before the interaction 
-                                      G4double kinEnergyProd // kinetic energy of the secondary particle 
-				      )
-{
- 
- return G4VEmAdjointModel::DiffCrossSectionPerVolumePrimToSecond(aMaterial,
-                                      			         kinEnergyProj,  // kinetic energy of the primary particle before the interaction 
-                                      			         kinEnergyProd);
-  
-}
-
-////////////////////////////////////////////////////////////////////////////////
-//
-G4double G4AdjointBremsstrahlungModel::SupressionFunction(const G4Material* material,
-                                 G4double kineticEnergy, G4double gammaEnergy)
-{
-  // supression due to the LPM effect+polarisation of the medium/
-  // supression due to the polarisation alone
-
-
-  G4double totEnergy = kineticEnergy+electron_mass_c2 ;
-  G4double totEnergySquare = totEnergy*totEnergy ;
-
-  G4double LPMEnergy = LPMconstant*(material->GetRadlen()) ;
-
-  G4double gammaEnergySquare = gammaEnergy*gammaEnergy ;
-
-  G4double electronDensity = material->GetElectronDensity();
-
-  G4double sp = gammaEnergySquare/
-   (gammaEnergySquare+MigdalConstant*totEnergySquare*electronDensity);
-
-  G4double supr = 1.0;
-
-  if (theLPMflag) {
-
-    G4double s2lpm = LPMEnergy*gammaEnergy/totEnergySquare;
-
-    if (s2lpm < 1.) {
-
-      G4double LPMgEnergyLimit = totEnergySquare/LPMEnergy ;
-      G4double LPMgEnergyLimit2 = LPMgEnergyLimit*LPMgEnergyLimit;
-      G4double splim = LPMgEnergyLimit2/
-        (LPMgEnergyLimit2+MigdalConstant*totEnergySquare*electronDensity);
-      G4double w = 1.+1./splim ;
-
-      if ((1.-sp) < 1.e-6) w = s2lpm*(3.-sp);
-      else                 w = s2lpm*(1.+1./sp);
-
-      supr = (std::sqrt(w*w+4.*s2lpm)-w)/(std::sqrt(w*w+4.)-w) ;
-      supr /= sp;    
-    } 
-    
-  } 
-  return supr;
-}
-
-////////////////////////////////////////////////////////////////////////////////
-//
-void G4AdjointBremsstrahlungModel::SampleSecondaries(const G4Track& aTrack,
-                       G4bool IsScatProjToProjCase,
-	               G4ParticleChange* fParticleChange)
-{ 
-
-  //G4cout<<"Adjoint Brem"<<std::endl;
-  const G4DynamicParticle* theAdjointPrimary =aTrack.GetDynamicParticle();
-  
-  size_t ind=0;
-  
-  if (UseMatrixPerElement ) { //Select Material
-   	std::vector<double>* CS_Vs_Element = &CS_Vs_ElementForScatProjToProjCase;
-  	if ( !IsScatProjToProjCase) CS_Vs_Element = &CS_Vs_ElementForProdToProjCase;
-  	G4double rand_var= G4UniformRand();
-  	G4double SumCS=0.;
-  	for (size_t i=0;i<CS_Vs_Element->size();i++){
- 		SumCS+=(*CS_Vs_Element)[i];
-		if (rand_var<=SumCS/lastCS){
-			ind=i;
-			break;
-		}
-  	}
-  }
-  else 	{
-  	ind = currentMaterialIndex;
-  }
- 
- 
- //Elastic inverse scattering modified compared to general G4VEmAdjointModel
- //---------------------------
- G4double adjointPrimKinEnergy = theAdjointPrimary->GetKineticEnergy();
- G4double adjointPrimTotalEnergy = theAdjointPrimary->GetTotalEnergy();
- //G4double adjointPrimP =theAdjointPrimary->GetTotalMomentum();
- if (adjointPrimKinEnergy>HighEnergyLimit*0.999){
- 	return;
- }
- 
- //Sample secondary energy
- //-----------------------
- 
- G4double projectileKinEnergy = SampleAdjSecEnergyFromCSMatrix(ind,
- 						   adjointPrimKinEnergy,
-						   IsScatProjToProjCase);
-				   
- 
- 
- 
- //Weight correction
- //-----------------------					   
- CorrectPostStepWeight(fParticleChange, aTrack.GetWeight(), adjointPrimKinEnergy,projectileKinEnergy);	
- 
- 
- //Kinematic
- //---------
- 
- G4double projectileM0 = electron_mass_c2;
- G4double projectileTotalEnergy = projectileM0+projectileKinEnergy;
- G4double projectileP2 = projectileTotalEnergy*projectileTotalEnergy - projectileM0*projectileM0;	
- G4double projectileP = std::sqrt(projectileP2);
- 
- 
- //Angle of the gamma direction with the projectile taken from G4eBremsstrahlungModel
- //------------------------------------------------
-  G4double u;
-  const G4double a1 = 0.625 , a2 = 3.*a1 , d = 27. ;
-
-  if (9./(9.+d) > G4UniformRand()) u = - std::log(G4UniformRand()*G4UniformRand())/a1;
-     else                          u = - std::log(G4UniformRand()*G4UniformRand())/a2;
-
-  G4double theta = u*electron_mass_c2/projectileTotalEnergy;
-
-  G4double sint = std::sin(theta);
-  G4double cost = std::cos(theta);
-
-  G4double phi = twopi * G4UniformRand() ;
-  
-  G4ThreeVector projectileMomentum;
-  projectileMomentum=G4ThreeVector(std::cos(phi)*sint,std::sin(phi)*sint,cost)*projectileP; //gamma frame
-  if (IsScatProjToProjCase) {//the adjoint primary is the scattered e-
-  	G4ThreeVector gammaMomentum = (projectileTotalEnergy-adjointPrimTotalEnergy)*G4ThreeVector(0.,0.,1.);
-	G4ThreeVector dirProd=projectileMomentum-gammaMomentum;
-	G4double cost1 = std::cos(dirProd.angle(projectileMomentum));
-	G4double sint1 =  std::sqrt(1.-cost1*cost1);
-	projectileMomentum=G4ThreeVector(std::cos(phi)*sint1,std::sin(phi)*sint1,cost1)*projectileP;
-  
-  }
-  
-  projectileMomentum.rotateUz(theAdjointPrimary->GetMomentumDirection());
- 
- 
- 
-  if (!IsScatProjToProjCase && CorrectWeightMode){ //kill the primary and add a secondary
- 	fParticleChange->ProposeTrackStatus(fStopAndKill);
- 	fParticleChange->AddSecondary(new G4DynamicParticle(theAdjEquivOfDirectPrimPartDef,projectileMomentum));
-	//G4cout<<"projectileMomentum "<<projectileMomentum<<std::endl;
+G4double G4AdjointBremsstrahlungModel::AdjointCrossSection(const G4MaterialCutsCouple* aCouple,
+				             G4double primEnergy,
+				             G4bool IsScatProjToProjCase)
+{/* if (UsePenelopeModel && !isPenelopeModelInitialised) {
+  	theEmModelManagerForFwdModels->Initialise(G4Electron::Electron(),G4Gamma::Gamma(),1.,0);
+	isPenelopeModelInitialised =true;
+  }
+  */
+  if (UseMatrix) return G4VEmAdjointModel::AdjointCrossSection(aCouple,primEnergy,IsScatProjToProjCase);
+  DefineCurrentMaterial(aCouple);
+  G4double Cross=0.;
+  lastCZ=theDirectEMModel->CrossSectionPerVolume(aCouple->GetMaterial(),theDirectPrimaryPartDef,100.*MeV,100.*MeV/exp(1.));//this give the constant above
+  
+  if (!IsScatProjToProjCase ){
+  	G4double Emax_proj = GetSecondAdjEnergyMaxForProdToProjCase(primEnergy);
+  	G4double Emin_proj = GetSecondAdjEnergyMinForProdToProjCase(primEnergy);
+	if (Emax_proj>Emin_proj && primEnergy > currentTcutForDirectSecond) Cross= lastCZ*log(Emax_proj/Emin_proj);
   }
   else {
- 	fParticleChange->ProposeEnergy(projectileKinEnergy);
-	fParticleChange->ProposeMomentumDirection(projectileMomentum.unit());
-	//G4cout<<"projectileMomentum "<<projectileMomentum<<std::endl;
-  }	
-} 
-////////////////////////////////////////////////////////////////////////////////
-//
-void G4AdjointBremsstrahlungModel::DefineDirectBremModel(G4eBremsstrahlungModel* aModel)
-{theDirectBremModel=aModel;
- DefineDirectEMModel(aModel);
-} 
-////////////////////////////////////////////////////////////////////////////////
-//
-void G4AdjointBremsstrahlungModel::InitialiseParameters()
-{  
-  static const G4double
-     ah10 = 4.67733E+00, ah11 =-6.19012E-01, ah12 = 2.02225E-02,
-     ah20 =-7.34101E+00, ah21 = 1.00462E+00, ah22 =-3.20985E-02,
-     ah30 = 2.93119E+00, ah31 =-4.03761E-01, ah32 = 1.25153E-02;
-
-  static const G4double
-     bh10 = 4.23071E+00, bh11 =-6.10995E-01, bh12 = 1.95531E-02,
-     bh20 =-7.12527E+00, bh21 = 9.69160E-01, bh22 =-2.74255E-02,
-     bh30 = 2.69925E+00, bh31 =-3.63283E-01, bh32 = 9.55316E-03;
-
- /* static const G4double
-     al00 =-2.05398E+00, al01 = 2.38815E-02, al02 = 5.25483E-04,
-     al10 =-7.69748E-02, al11 =-6.91499E-02, al12 = 2.22453E-03,
-     al20 = 4.06463E-02, al21 =-1.01281E-02, al22 = 3.40919E-04;
-
-  static const G4double
-     bl00 = 1.04133E+00, bl01 =-9.43291E-03, bl02 =-4.54758E-04,
-     bl10 = 1.19253E-01, bl11 = 4.07467E-02, bl12 =-1.30718E-03,
-     bl20 =-1.59391E-02, bl21 = 7.27752E-03, bl22 =-1.94405E-04;*/
- 
-  
-  const G4ElementTable* theElementTable = G4Element::GetElementTable();
-  FZ.clear();
-  ah1.clear();
-  ah2.clear();
-  ah3.clear();
-  
-  bh1.clear();
-  bh2.clear();
-  bh3.clear();
-  
-  al0.clear();
-  al1.clear();
-  al2.clear();
-  
-  bl0.clear();
-  bl1.clear();
-  bl2.clear();
-  SigmaPerAtom.clear(); 
-  
-  for (size_t j=0; j<theElementTable->size();j++){
-	
-	G4Element* anElement=(*theElementTable)[j]; 
-	G4double lnZ = 3.*(anElement->GetIonisation()->GetlogZ3());
-  	FZ.push_back(lnZ* (4.- 0.55*lnZ));
-  	G4double ZZ = anElement->GetIonisation()->GetZZ3();
-	
-	ah1.push_back(ah10 + ZZ* (ah11 + ZZ* ah12));
-        ah2.push_back(ah20 + ZZ* (ah21 + ZZ* ah22));
-        ah3.push_back(ah30 + ZZ* (ah31 + ZZ* ah32));
-
-        bh1.push_back(bh10 + ZZ* (bh11 + ZZ* bh12));
-        bh2.push_back(bh20 + ZZ* (bh21 + ZZ* bh22));
-        bh3.push_back(bh30 + ZZ* (bh31 + ZZ* bh32));
-	/*SigmaPerAtom.push_back(theDirectEMModel->ComputeCrossSectionPerAtom(
-					theDirectPrimaryPartDef,GetHighEnergyLimit()/2., 
-					anElement->GetZ(),1.,GetLowEnergyLimit(),1.e20));*/
-	
-	
+  	G4double Emax_proj = GetSecondAdjEnergyMaxForScatProjToProjCase(primEnergy);
+	G4double Emin_proj = GetSecondAdjEnergyMinForScatProjToProjCase(primEnergy,currentTcutForDirectSecond);
+	if (Emax_proj>Emin_proj) Cross= lastCZ*log((Emax_proj-primEnergy)*Emin_proj/Emax_proj/(Emin_proj-primEnergy));
   	
-  }	
-}
+  }
+  return Cross;	
+}					     
+
+
+
+
+
